    /*!
     * Ext JS Library 3.3.1
     * Copyright(c) 2006-2010 Sencha Inc.
     * licensing@sencha.com
     * http://www.sencha.com/license
     */
    /**
     * @class Ext.data.XmlWriter
     * @extends Ext.data.DataWriter
     * DataWriter extension for writing an array or single {@link Ext.data.Record} object(s) in preparation for executing a remote CRUD action via XML.
     * XmlWriter uses an instance of {@link Ext.XTemplate} for maximum flexibility in defining your own custom XML schema if the default schema is not appropriate for your needs.
     * See the {@link #tpl} configuration-property.
     */
    Ext.data.XmlWriter = function(params) {
        Ext.data.XmlWriter.superclass.constructor.apply(this, arguments);
        // compile the XTemplate for rendering XML documents.
        this.tpl = (typeof(this.tpl) === 'string') ? new Ext.XTemplate(this.tpl).compile() : this.tpl.compile();
    };
    Ext.extend(Ext.data.XmlWriter, Ext.data.DataWriter, {
        /**
         * @cfg {String} documentRoot [xrequest] (Optional) The name of the XML document root-node.  Note:
         * this parameter is required only when sending extra {@link Ext.data.Store#baseParams baseParams} to the server
         * during a write-request -- if no baseParams are set, the {@link Ext.data.XmlReader#record} meta-property can
         * suffice as the XML document root-node for write-actions involving just a single record.  For requests
         * involving multiple records and NO baseParams, the {@link Ext.data.XmlWriter#root} property can
         * act as the XML document root.
         */
        documentRoot: 'xrequest',
        /**
         * @cfg {Boolean} forceDocumentRoot [false] Set to true to force XML documents having a root-node as defined
         * by {@link #documentRoot}, even with no baseParams defined.
         */
        forceDocumentRoot: false,
        /**
         * @cfg {String} root [records] The name of the containing element which will contain the nodes of an write-action involving multiple records.  Each
         * xml-record written to the server will be wrapped in an element named after {@link Ext.data.XmlReader#record} property.
         * eg:

    <?xml version="1.0" encoding="UTF-8"?>
    <user><first>Barney</first></user>

* However, when multiple records are written in a batch-operation, these records must be wrapped in a containing * Element. * eg: `

    <?xml version="1.0" encoding="UTF-8"?>
        <records>
            <first>Barney</first></user>
            <records><first>Barney</first></user>
        </records>

` * Defaults to `records`. Do not confuse the nature of this property with that of {@link #documentRoot} */ root: 'records',
/** * @cfg {String} xmlVersion [1.0] The `version` written to header of xml documents. `

    <?xml version="1.0" encoding="ISO-8859-15"?>

` */ xmlVersion : '1.0',
/** * @cfg {String} xmlEncoding [ISO-8859-15] The `encoding` written to header of xml documents. `

    <?xml version="1.0" encoding="ISO-8859-15"?>

` */ xmlEncoding: 'ISO-8859-15',
/** * @cfg {String/Ext.XTemplate} tpl The XML template used to render {@link Ext.data.Api#actions write-actions} to your server. *

One can easily provide his/her own custom {@link Ext.XTemplate#constructor template-definition} if the default does not suffice.

*

Defaults to:

`

    <?xml version="{version}" encoding="{encoding}"?>
        <tpl if="documentRoot"><{documentRoot}>
        <tpl for="baseParams">
            <tpl for=".">
                <{name}>{value}</{name}>
            </tpl>
        </tpl>
        <tpl if="records.length > 1"><{root}>',
        <tpl for="records">
            <{parent.record}>
            <tpl for=".">
                <{name}>{value}</{name}>
            </tpl>
            </{parent.record}>
        </tpl>
        <tpl if="records.length > 1"></{root}></tpl>
        <tpl if="documentRoot"></{documentRoot}></tpl>

` *

Templates will be called with the following API

*

*
- {String} version [1.0] The xml version.
*
- {String} encoding [ISO-8859-15] The xml encoding.
*
- {String/false} documentRoot The XML document root-node name or `false` if not required. See {@link #documentRoot} and {@link #forceDocumentRoot}.
*
- {String} record The meta-data parameter defined on your {@link Ext.data.XmlReader#record} configuration represents the name of the xml-tag containing each record.
*
- {String} root The meta-data parameter defined by {@link Ext.data.XmlWriter#root} configuration-parameter. Represents the name of the xml root-tag when sending multiple records to the server.
*
- {Array} records The records being sent to the server, ie: the subject of the write-action being performed. The records parameter will be always be an array, even when only a single record is being acted upon. * Each item within the records array will contain an array of field objects having the following properties: *
  *
  - {String} name The field-name of the record as defined by your {@link Ext.data.Record#create Ext.data.Record definition}. The "mapping" property will be used, otherwise it will match the "name" property. Use this parameter to define the XML tag-name of the property.
  *
  - {Mixed} value The record value of the field enclosed within XML tags specified by name property above.
  *
*
- {Array} baseParams. The baseParams as defined upon {@link Ext.data.Store#baseParams}. Note that the baseParams have been converted into an array of [{name : "foo", value: "bar"}, ...] pairs in the same manner as the records parameter above. See {@link #documentRoot} and {@link #forceDocumentRoot}.
*

*/ // Encoding the ? here in case it's being included by some kind of page that will parse it (eg. PHP) tpl: '<\u003fxml version="{version}" encoding="{encoding}"\u003f><{documentRoot}><{name}>{value}<{root}><{parent.record}><{name}>{value}',
/** * XmlWriter implementation of the final stage of a write action. * @param {Object} params Transport-proxy's (eg: {@link Ext.Ajax#request}) params-object to write-to. * @param {Object} baseParams as defined by {@link Ext.data.Store#baseParams}. The baseParms must be encoded by the extending class, eg: {@link Ext.data.JsonWriter}, {@link Ext.data.XmlWriter}. * @param {Object/Object[]} data Data-object representing the compiled Store-recordset. */ render : function(params, baseParams, data) { baseParams = this.toArray(baseParams); params.xmlData = this.tpl.applyTemplate({ version: this.xmlVersion, encoding: this.xmlEncoding, documentRoot: (baseParams.length > 0 || this.forceDocumentRoot === true) ? this.documentRoot : false, record: this.meta.record, root: this.root, baseParams: baseParams, records: (Ext.isArray(data[0])) ? data : [data] }); },
/** * createRecord * @protected * @param {Ext.data.Record} rec * @return {Array} Array of `name:value` pairs for attributes of the {@link Ext.data.Record}. See {@link Ext.data.DataWriter#toHash}. */ createRecord : function(rec) { return this.toArray(this.toHash(rec)); },
/** * updateRecord * @protected * @param {Ext.data.Record} rec * @return {Array} Array of {name:value} pairs for attributes of the {@link Ext.data.Record}. See {@link Ext.data.DataWriter#toHash}. */ updateRecord : function(rec) { return this.toArray(this.toHash(rec)); },
/** * destroyRecord * @protected * @param {Ext.data.Record} rec * @return {Array} Array containing a attribute-object (name/value pair) representing the {@link Ext.data.DataReader#idProperty idProperty}. */ destroyRecord : function(rec) { var data = {}; data[this.meta.idProperty] = rec.id; return this.toArray(data); } });